	.dbfile C:\iccv7arm\MI533D~1\MICROB~4\MicroBoltHelloWorld.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Delay -> R6
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 38
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltHelloWorld.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 4/2/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; 
; #include "MicroBoltHelloWorld.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 46
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 48
; 
;   SCB_PLLCFG |= 0x23;				 	   		            // Turn on PLL, set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+0
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 49
;   SCB_PLLCON |= 0x03;
	ldr R4,LIT_main+4
	ldr R5,[R4,#0]
	orr R5,R5,#3
	str R5,[R4,#0]
	.dbline 50
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy for PLL
	mov R4,#170
	ldr R5,LIT_main+8
	str R4,[R5,#0]
	.dbline 51
;   SCB_PLLFEED = 0x55; 
	mov R4,#85
	ldr R5,LIT_main+8
	str R4,[R5,#0]
	.dbline 53
; 
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port
	mov R4,#0
	ldr R5,LIT_main+12
	str R4,[R5,#0]
	.dbline 54
;   PCB_PINSEL1=0x55400000;
	ldr R4,LIT_main+16
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 55
;   GPIO_IODIR=(0x00000000<<16)|
	mov R4,#0
	ldr R5,LIT_main+24
	str R4,[R5,#0]
	.dbline 58
; 	     0x00000000;
;  
;   GPIO_IOCLR=0xffffffff;
	mvn R4,#0
	ldr R5,LIT_main+28
	str R4,[R5,#0]
	.dbline 59
;   GPIO_IOSET=(0x00000000<<16)| 
	mov R4,#0
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 62
;             0x00000000;  
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+24
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 64
; 
;   PCB_PINSEL0 |= P0_0_UART_0_TX;                // Setup P0.0 to alternate function UART0-TX
	ldr R4,LIT_main+12
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 64
	.dbline 66
; 
;   UART0_LCR = 0x00000083;	 	                    // Enable the divisor
	mov R4,#131
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 67
;   UART0_DLM = 0;				                        // Divisor latch MSB (for baud rates < 4800) 
	mov R4,#0
	ldr R5,LIT_main+40
	str R4,[R5,#0]
	.dbline 68
;   UART0_DLL = BAUD_RATE_115200;			            // Divisor latch LSB 
	mov R4,#8
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 69
;   UART0_LCR = 0x00000003;  	                    // Close LCR, now UART works with divisor
	mov R4,#3
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	b L3
L2:
	.dbline 78
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                            // Do this forever
;     {
	.dbline 81
;     unsigned int Delay;
; 
;     GPIO_IOSET = MICROBOLT_LED;                       // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 82
;     SendSerialStringUart0("Hello World...", FALSE);   // Output string via UART-0, No carriage return or line feed
	ldr R0,LIT_main+48
	mov R1,#0
	bl _SendSerialStringUart0
	.dbline 83
	mov R6,#0
	b L9
L6:
	.dbline 83
L7:
	.dbline 83
	add R6,R6,#1
L9:
	.dbline 83
;     for (Delay = 0; Delay < 780000; Delay++);         // Delay for 1 Second
	ldr R4,LIT_main+52
	cmp R6,R4
	blo L6
	.dbline 85
; 
;     GPIO_IOCLR = MICROBOLT_LED;                       // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+28
	str R4,[R5,#0]
	.dbline 86
;     SendSerialStringUart0("from MicroBolt!", TRUE);   // Output string via UART-0 with carriage return and line feed
	ldr R0,LIT_main+56
	mov R1,#1
	bl _SendSerialStringUart0
	.dbline 87
	mov R6,#0
	b L14
L11:
	.dbline 87
L12:
	.dbline 87
	add R6,R6,#1
L14:
	.dbline 87
	ldr R4,LIT_main+52
	cmp R6,R4
	blo L11
	.dbline 88
L3:
	.dbline 77
	b L2
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536707068
	DCD -536821748
	DCD -536821756
	DCD -536821760
	DCD L5
	DCD 780000
	DCD L10
	.dbsym r Delay 6 i
	.dbend
	EXPORT _Uart0TxByte
	.dbfunc e Uart0TxByte _Uart0TxByte fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;     SerialByte -> R4
_Uart0TxByte:
	mov R12,R13
	stmfd R13!,{R4,R12,R14}
	mov R4,R0
	.dbline -1
	.dbline 102
;     for (Delay = 0; Delay < 780000; Delay++);         // Delay for 1 Second                
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Uart0TxByte
; |     Inputs          :   Byte for transmission
; |     Outputs         :   None
; |     Purpose         :   Transmit a byte via UART0
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void Uart0TxByte(unsigned char SerialByte)
;   {
L16:
	.dbline 103
L17:
	.dbline 103
;   while (!(UART0_LSR & 0x20)); 
	ldr R0,LIT_Uart0TxByte+0
	ldr R0,[R0,#0]
	tst R0,#32
	beq L16
	.dbline 104
;   UART0_THR = SerialByte;
	and R0,R4,#255
	ldr R1,LIT_Uart0TxByte+4
	str R0,[R1,#0]
	.dbline -2
L15:
	ldmfd R13!,{R4,SP,PC}
	.dbline 0 ; func end
LIT_Uart0TxByte:
	DCD -536821740
	DCD -536821760
	.dbsym r SerialByte 4 c
	.dbend
	EXPORT _SendSerialStringUart0
	.dbfunc e SendSerialStringUart0 _SendSerialStringUart0 fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;              i -> R5
; SendCarriageReturnLineFeed -> R6
;   SerialString -> R7
_SendSerialStringUart0:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R7,R11,R12,R14}
	mov R11,R13
	mov R7,R0
	mov R6,R1
	.dbline -1
	.dbline 118
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   SendSerialStringUart0
; |     Inputs          :   Serial string and option for CR and LF
; |     Outputs         :   None
; |     Purpose         :   Transmit a serial string via UART0
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void SendSerialStringUart0(char SerialString[], char SendCarriageReturnLineFeed)
; 	{
	.dbline 119
; 	unsigned char i = 0;
	mov R5,#0
	b L21
L20:
	.dbline 122
	.dbline 123
	and R4,R5,#255
	ldrb R0,[R4,+R7]
	bl _Uart0TxByte
	.dbline 124
	and R4,R5,#255
	add R4,R4,#1
	mov R5,R4
	.dbline 125
L21:
	.dbline 121
	and R4,R5,#255
	ldrb R4,[R4,+R7]
	cmp R4,#0
	bne L20
	.dbline 127
	and R4,R6,#255
	cmp R4,#1
	bne L23
	.dbline 128
	.dbline 129
	mov R0,#13
	bl _Uart0TxByte
	.dbline 130
	mov R0,#10
	bl _Uart0TxByte
	.dbline 131
L23:
	.dbline -2
L19:
	ldmfd R11,{R4,R5,R6,R7,R11,SP,PC}
	.dbline 0 ; func end
	.dbsym r i 5 c
	.dbsym r SendCarriageReturnLineFeed 6 c
	.dbsym r SerialString 7 pc
	.dbend
	AREA	"C$$code", CODE, READONLY
L10:
	DCB "from MicroBolt!", 0
L5:
	DCB "Hello World...", 0
	END
